// Code generated by go-swagger; DO NOT EDIT.

package engines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteOryAccessControlPolicyParams creates a new DeleteOryAccessControlPolicyParams object
// with the default values initialized.
func NewDeleteOryAccessControlPolicyParams() *DeleteOryAccessControlPolicyParams {
	var ()
	return &DeleteOryAccessControlPolicyParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteOryAccessControlPolicyParamsWithTimeout creates a new DeleteOryAccessControlPolicyParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteOryAccessControlPolicyParamsWithTimeout(timeout time.Duration) *DeleteOryAccessControlPolicyParams {
	var ()
	return &DeleteOryAccessControlPolicyParams{

		timeout: timeout,
	}
}

// NewDeleteOryAccessControlPolicyParamsWithContext creates a new DeleteOryAccessControlPolicyParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteOryAccessControlPolicyParamsWithContext(ctx context.Context) *DeleteOryAccessControlPolicyParams {
	var ()
	return &DeleteOryAccessControlPolicyParams{

		Context: ctx,
	}
}

// NewDeleteOryAccessControlPolicyParamsWithHTTPClient creates a new DeleteOryAccessControlPolicyParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDeleteOryAccessControlPolicyParamsWithHTTPClient(client *http.Client) *DeleteOryAccessControlPolicyParams {
	var ()
	return &DeleteOryAccessControlPolicyParams{
		HTTPClient: client,
	}
}

/*DeleteOryAccessControlPolicyParams contains all the parameters to send to the API endpoint
for the delete ory access control policy operation typically these are written to a http.Request
*/
type DeleteOryAccessControlPolicyParams struct {

	/*Flavor
	  The ORY Access Control Policy flavor. Can be "regex", "glob", and "exact".

	*/
	Flavor string
	/*ID
	  The ID of the ORY Access Control Policy Role.

	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) WithTimeout(timeout time.Duration) *DeleteOryAccessControlPolicyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) WithContext(ctx context.Context) *DeleteOryAccessControlPolicyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) WithHTTPClient(client *http.Client) *DeleteOryAccessControlPolicyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFlavor adds the flavor to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) WithFlavor(flavor string) *DeleteOryAccessControlPolicyParams {
	o.SetFlavor(flavor)
	return o
}

// SetFlavor adds the flavor to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) SetFlavor(flavor string) {
	o.Flavor = flavor
}

// WithID adds the id to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) WithID(id string) *DeleteOryAccessControlPolicyParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete ory access control policy params
func (o *DeleteOryAccessControlPolicyParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteOryAccessControlPolicyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param flavor
	if err := r.SetPathParam("flavor", o.Flavor); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
